function RobotDefense:StartActivity()
	print("Robot Defense Activity Start");
	self.FightStage = { NOFIGHT = 0, DEFENDING = 1, ATTACK = 2, FIGHTSTAGECOUNT = 3 };
	self.rspawn1 = Timer();
	self.rspawn2 = Timer();
	self.rspawn3 = Timer();
	self.gametime = Timer();
	self.gametime:SetRealTimeLimitS(30);
	self.gameover = 0;
	self.rtime = 5000;
	self.InterruptTimer = Timer();
	self.Interrupt = 0;
	ActivityMan:GetActivity():SetTeamFunds(0,0);
	playerActor = CreateAHuman("Marcus Wright");
	playerActor.Pos = Vector(2508,876);
	playerActor.Team = 0;
	self:SetPlayerBrain(playerActor, 0);
	self:SetLandingZone(playerActor.Pos, 0);
	playerActor:AddInventoryItem(CreateHDFirearm("RDM16"));
	MovableMan:AddActor(playerActor);
	self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
	rlist = {"Terminator Robot","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2","R2"};
	wlist = {"RDGG","RDLR"};
	robotcount = 0;
	robotcap = 10;
	killcount = 0;
	pickup1 = 0;
	pickup2 = 0;
	pickup3 = 0;
	pickup4 = 0;
	pickup5 = 0;
	pickup6 = 0;
	pickup7 = 0;
end
	
function RobotDefense:PauseActivity()
	print("Robot Defense Activity Paused");
end

function RobotDefense:EndActivity()
	print("Robot Defense GAME OVER");
	self.gameover = 1;
	if self.WinnerTeam == Activity.TEAM_2 then
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("You're dead.  You were the last guy, too. So much for the hum--oh right. NEVERMIND.", Activity.PLAYER_1, 0, 5000, false);
	else
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("My god, you withstood the onslaught of ONE THOUSAND robots. You is a champeen.", Activity.PLAYER_1, 0, 5000, false);
	end
end

function RobotDefense:UpdateActivity()
	if MovableMan:IsActor(playerActor) then
		self:SetObservationTarget(playerActor.Pos, Activity.PLAYER_1);
	end
	
	if playerActor.Health <= 0 or MovableMan:IsActor(playerActor) == false then
		self.WinnerTeam = Activity.TEAM_2;
		ActivityMan:EndActivity();
	end

	if robotcount < robotcap then
		if -self.rspawn1:LeftTillSimMS(0) > self.rtime then
			local robot1 = CreateAHuman(rlist[math.random(#rlist)]);
			robot1:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			robot1.Pos = Vector(400,850);
			robot1.HitsMOs = false;
			robot1.Team = -1;
			robot1.AIMode = Actor.AIMODE_GOTO;
			robot1:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			robot1:AddInventoryItem(CreateHDFirearm("Heavy Digger"));
			MovableMan:AddActor(robot1);
			self.rspawn1:Reset();
			robotcount = robotcount + 1;
		end
		if -self.rspawn2:LeftTillSimMS(0) > self.rtime then
			local robot2 = CreateAHuman(rlist[math.random(#rlist)]);
			robot2:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			robot2.Pos = Vector(600,850);
			robot2.HitsMOs = false;
			robot2.Team = -1;
			robot2.AIMode = Actor.AIMODE_GOTO;
			robot2:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			robot2:AddInventoryItem(CreateHDFirearm("Medium Digger"));
			MovableMan:AddActor(robot2);
			self.rspawn2:Reset();
			robotcount = robotcount + 1;
		end
		if -self.rspawn3:LeftTillSimMS(0) > self.rtime then
			local robot3 = CreateAHuman(rlist[math.random(#rlist)]);
			robot3:AddAISceneWaypoint(Vector(3000,playerActor.Pos.Y));
			robot3.Pos = Vector(800,850);
			robot3.HitsMOs = false;
			robot3.Team = -1;
			robot3.AIMode = Actor.AIMODE_GOTO;
			robot3:AddInventoryItem(CreateHDFirearm(wlist[math.random(#wlist)]));
			robot3:AddInventoryItem(CreateHDFirearm("Heavy Digger"));
			MovableMan:AddActor(robot3);
			self.rspawn3:Reset();
			robotcount = robotcount + 1;
		end
	end
	
	for actor in MovableMan.Actors do
        if SceneMan.Scene:WithinArea("Boundary", actor.Pos) then
			if actor.Team == 0 then
				actor.Vel = actor.Vel * -1;
			end
        end
    end
	
	for item in MovableMan.Items do
		if item.PresetName == "RDGG" then
			item.ToSettle = true;
		end
		if item.PresetName == "RDLR" then
			item.ToSettle = true;
		end
		if item.PresetName == "Heavy Digger" then
			item.ToSettle = true;
		end
		if item.PresetName == "Medium Digger" then
			item.ToSettle = true;
		end
	end
	
	if killcount >= 25 and pickup1 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDGG"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Twenty five robots killed! Gatling Gun unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup1 = 1;
		robotcap = 20;
	end

	if killcount >= 50 and pickup2 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDSR"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Fifty robots killed! Sniper Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup2 = 1;
		self.rtime = 4500;
	end
	
	if killcount >= 75 and pickup3 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDHSR"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Seventy five robots killed! Heavy Sniper Rifle unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup3 = 1;
		self.rtime = 4000;
	end
	
	if killcount >= 100 and pickup4 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDAC"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("One hundred robots killed! Auto Cannon unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup4 = 1;
		robotcap = 30;
		self.rtime = 3000;
		if playerActor.Health < 85 then
			self.Interrupt = 5000;
			self.InterruptTimer:Reset();
			self:ResetMessageTimer(Activity.PLAYER_1);
			FrameMan:ClearScreenText(Activity.PLAYER_1);
			FrameMan:SetScreenText("NANOBOT SWARM, HEALTH UPGRADED", Activity.PLAYER_1, 0, 5000, false);
			playerActor.Health = playerActor.Health + 15;
		end
	end
	
	if killcount >= 200 and pickup5 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDM1600"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Two hundred robots killed! M1600 unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup5 = 1;
	end
	
	if killcount >= 400 and pickup6 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDRC"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Four hundred robots killed! Revolver Cannon unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup6 = 1;
		robotcap = 40;
	end
	
	if killcount >= 750 and pickup7 == 0 then
		playerActor:AddInventoryItem(CreateHDFirearm("RDRL"),"Robot Defense.rte");
		self.Interrupt = 5000;
		self.InterruptTimer:Reset();
		self:ResetMessageTimer(Activity.PLAYER_1);
        FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("Seven hundred fifty robots killed! Rocket launcher unlocked!", Activity.PLAYER_1, 0, 5000, false);
		pickup7 = 1;
		self.rtime = 2500;
	end
	
	if killcount >= 1000 then
		self.WinnerTeam = Activity.TEAM_1;
		ActivityMan:EndActivity();
	end
end
	